//Alex Seehagen
//Suavizacao de Solidos - Algoritmo de Catmull-Clark

#include <stdlib.h>
#include <stdio.h>
#include <GL/glut.h>

GLfloat tam = 3;
GLfloat xRot=0;
GLfloat yRot=0;
int tipo = 1;

/****************************************************************/
//estrutura original do cubo e tetraedro
/****************************************************************/
GLfloat vertices[8][3] = {    
   {1, 1, 1}, {-1, 1, 1}, {-1, -1, 1}, {1, -1, 1},
   {1, -1, -1}, {1, 1, -1}, {-1, 1, -1}, {-1, -1, -1}
};

GLfloat tetvertices[4][3] = {    
   {1, 1, 1}, {-1, -1, 1}, {-1, 1, -1}, {1, -1, -1}
};

//faces baseadas em vertices
static GLint faces[6][4] = { 
   {0,1,2,3}, {0,3,4,5}, {0,5,6,1}, {1,6,7,2}, {7,4,3,2}, {4,7,6,5} };
   
   
static GLint tetfaces[4][3] = { 
   {0,1,2}, {0,1,3}, {0,2,3}, {1,2,3} };
   


/****************************************************************/
//estruturas adicionais do cubo
/****************************************************************/

GLfloat vertices1[26][3] = { }; // todos os vertex
GLint faces1[24][4] = { }; //faces interacao 1 com indices corretos

GLfloat vertices2[98][3] = { }; // todos os vertex
GLint faces2[96][4] = { }; //faces interacao 2 com indices corretos

GLfloat vertices3[386][3] = { }; // todos os vertex
GLint faces3[384][4] = { }; //faces interacao 3 com indices corretos


/****************************************************************/
//estruturas adicionais do tetraedro
/****************************************************************/

GLfloat tetvertices1[14][3] = { }; // todos os vertex
GLint tetfaces1[12][4] = { }; //faces interacao 1 com indices corretos

GLfloat tetvertices2[50][3] = { }; // todos os vertex
GLint tetfaces2[48][4] = { }; //faces interacao 2 com indices corretos

GLfloat tetvertices3[194][3] = { }; // todos os vertex
GLint tetfaces3[192][4] = { }; //faces interacao 3 com indices corretos



/****************************************************************/
//desenha cubo original
/****************************************************************/
void desenha_cubo(){
     for (int i = 0; i < 6; i++) {    
           glBegin(GL_LINE_STRIP);
              glVertex3fv(&vertices[faces[i][0]][0]); 
              glVertex3fv(&vertices[faces[i][1]][0]); 
              glVertex3fv(&vertices[faces[i][2]][0]);
              glVertex3fv(&vertices[faces[i][3]][0]);     
           glEnd(); 
     }

}

/****************************************************************/
//desenha cubo suavizado 1a interacao
/****************************************************************/
void desenha_cubo1(){
    glPointSize(1.0);
    for (int i=0;i<24;i++){
        glBegin(GL_LINE_STRIP);
        glVertex3f(vertices1[faces1[i][0]][0],vertices1[faces1[i][0]][1],vertices1[faces1[i][0]][2]);
        glVertex3f(vertices1[faces1[i][1]][0],vertices1[faces1[i][1]][1],vertices1[faces1[i][1]][2]);
        glVertex3f(vertices1[faces1[i][2]][0],vertices1[faces1[i][2]][1],vertices1[faces1[i][2]][2]);
        glVertex3f(vertices1[faces1[i][3]][0],vertices1[faces1[i][3]][1],vertices1[faces1[i][3]][2]);
        glVertex3f(vertices1[faces1[i][0]][0],vertices1[faces1[i][0]][1],vertices1[faces1[i][0]][2]);
        glEnd();            
    }

}


/****************************************************************/
//desenha cubo suavizado 2a interacao
/****************************************************************/
void desenha_cubo2(){
    glPointSize(1.0);
    for (int i=0;i<96;i++){
        glBegin(GL_LINE_STRIP);
        glVertex3f(vertices2[faces2[i][0]][0],vertices2[faces2[i][0]][1],vertices2[faces2[i][0]][2]);
        glVertex3f(vertices2[faces2[i][1]][0],vertices2[faces2[i][1]][1],vertices2[faces2[i][1]][2]);
        glVertex3f(vertices2[faces2[i][2]][0],vertices2[faces2[i][2]][1],vertices2[faces2[i][2]][2]);
        glVertex3f(vertices2[faces2[i][3]][0],vertices2[faces2[i][3]][1],vertices2[faces2[i][3]][2]);
        glVertex3f(vertices2[faces2[i][0]][0],vertices2[faces2[i][0]][1],vertices2[faces2[i][0]][2]);
        glEnd();            
    }

}


/****************************************************************/
//desenha cubo suavizado 3a interacao
/****************************************************************/
void desenha_cubo3(){
    glPointSize(1.0);
    for (int i=0;i<384;i++){
        glBegin(GL_LINE_STRIP);
        glVertex3f(vertices3[faces3[i][0]][0],vertices3[faces3[i][0]][1],vertices3[faces3[i][0]][2]);
        glVertex3f(vertices3[faces3[i][1]][0],vertices3[faces3[i][1]][1],vertices3[faces3[i][1]][2]);
        glVertex3f(vertices3[faces3[i][2]][0],vertices3[faces3[i][2]][1],vertices3[faces3[i][2]][2]);
        glVertex3f(vertices3[faces3[i][3]][0],vertices3[faces3[i][3]][1],vertices3[faces3[i][3]][2]);
        glVertex3f(vertices3[faces3[i][0]][0],vertices3[faces3[i][0]][1],vertices3[faces3[i][0]][2]);
        glEnd();            
    }

}



/****************************************************************/
//desenha tetraedro original
/****************************************************************/
void desenha_tetraedro(){

   for (int i = 0; i < 4; i++) {    
   
      glBegin(GL_LINE_STRIP);
          glVertex3fv(&tetvertices[tetfaces[i][0]][0]); 
          glVertex3fv(&tetvertices[tetfaces[i][1]][0]); 
          glVertex3fv(&tetvertices[tetfaces[i][2]][0]);
          glVertex3fv(&tetvertices[tetfaces[i][0]][0]);     
      glEnd(); 
   }
}   


/****************************************************************/
//desenha tetraedro suavizado - 1a interacao
/****************************************************************/
void desenha_tetraedro1(){

    glPointSize(1.0);
    for (int i=0;i<12;i++){
            glBegin(GL_LINE_STRIP);
            glVertex3f(tetvertices1[tetfaces1[i][0]][0],tetvertices1[tetfaces1[i][0]][1],tetvertices1[tetfaces1[i][0]][2]);
            glVertex3f(tetvertices1[tetfaces1[i][1]][0],tetvertices1[tetfaces1[i][1]][1],tetvertices1[tetfaces1[i][1]][2]);
            glVertex3f(tetvertices1[tetfaces1[i][2]][0],tetvertices1[tetfaces1[i][2]][1],tetvertices1[tetfaces1[i][2]][2]);
            glVertex3f(tetvertices1[tetfaces1[i][3]][0],tetvertices1[tetfaces1[i][3]][1],tetvertices1[tetfaces1[i][3]][2]);
            glVertex3f(tetvertices1[tetfaces1[i][0]][0],tetvertices1[tetfaces1[i][0]][1],tetvertices1[tetfaces1[i][0]][2]);
            glEnd();            
    }
} 



/****************************************************************/
//desenha tetraedro suavizado - 2a interacao
/****************************************************************/
void desenha_tetraedro2(){

    glPointSize(1.0);
    for (int i=0;i<48;i++){
            glBegin(GL_LINE_STRIP);
            glVertex3f(tetvertices2[tetfaces2[i][0]][0],tetvertices2[tetfaces2[i][0]][1],tetvertices2[tetfaces2[i][0]][2]);
            glVertex3f(tetvertices2[tetfaces2[i][1]][0],tetvertices2[tetfaces2[i][1]][1],tetvertices2[tetfaces2[i][1]][2]);
            glVertex3f(tetvertices2[tetfaces2[i][2]][0],tetvertices2[tetfaces2[i][2]][1],tetvertices2[tetfaces2[i][2]][2]);
            glVertex3f(tetvertices2[tetfaces2[i][3]][0],tetvertices2[tetfaces2[i][3]][1],tetvertices2[tetfaces2[i][3]][2]);
            glVertex3f(tetvertices2[tetfaces2[i][0]][0],tetvertices2[tetfaces2[i][0]][1],tetvertices2[tetfaces2[i][0]][2]);
            glEnd();            
    }
} 


/****************************************************************/
//desenha tetraedro suavizado - 3a interacao
/****************************************************************/
void desenha_tetraedro3(){

    glPointSize(1.0);
    for (int i=0;i<192;i++){
            glBegin(GL_LINE_STRIP);
            glVertex3f(tetvertices3[tetfaces3[i][0]][0],tetvertices3[tetfaces3[i][0]][1],tetvertices3[tetfaces3[i][0]][2]);
            glVertex3f(tetvertices3[tetfaces3[i][1]][0],tetvertices3[tetfaces3[i][1]][1],tetvertices3[tetfaces3[i][1]][2]);
            glVertex3f(tetvertices3[tetfaces3[i][2]][0],tetvertices3[tetfaces3[i][2]][1],tetvertices3[tetfaces3[i][2]][2]);
            glVertex3f(tetvertices3[tetfaces3[i][3]][0],tetvertices3[tetfaces3[i][3]][1],tetvertices3[tetfaces3[i][3]][2]);
            glVertex3f(tetvertices3[tetfaces3[i][0]][0],tetvertices3[tetfaces3[i][0]][1],tetvertices3[tetfaces3[i][0]][2]);
            glEnd();            
    }
} 









/****************************************************************/
//CONSTRI cubo - 1a interacao
/****************************************************************/
void cubo_interacao1()
{
GLfloat fv[6][3] = { }; //face vertex
GLfloat ev[12][3] = { }; //edge vertex
GLfloat vv[8][3] = { }; // vertex vertex
GLint fint[24][4] = { }; //faces interacao 1 com indices separados p/ fv, ev, vv


//deriva a estrutura de arestas a partir das faces e dos vertices
GLint arestas[12][2] = { };// declaracao deve ser dentro da funcao
int aux = 0;
for (int i=0; i<6;i++){ //p cada face
    for (int j=0; j<4;j++){ //p cada vertice de uma face (-1)
        int aux2 = 0;
        int aux1 = faces[i][j];
        if (j==3){aux2 = faces[i][0];}else{
        aux2 = faces[i][j+1];}
        
        int flag = 0; //variavel q diz se existe associacao
        for (int k=0; k<=aux;k++){ //verifica se jah existe essa associacao
            if(arestas[k][0] == aux1){
                if(arestas[k][1] == aux2){flag = 1;}
            }
            if(arestas[k][1] == aux1){
                if(arestas[k][0] == aux2){flag = 1;}
            }
        }
        if (flag == 0){ //cria associacao
           arestas[aux][0] = aux1;
           arestas[aux][1] = aux2;
           //printf("arestas%i = ( %i , %i)\n",aux,arestas[aux][0],arestas[aux][1]);
           aux ++;
        }
    }
}


//deriva a estrutura de arestas baseadas em faces
GLint arestaf[12][2] = { };
for (int i=0;i<12;i++){ //p cada aresta pega os 2 vertices
    int v1 = arestas[i][0]; 
    int v2 = arestas[i][1];

    //busca as faces vizinhas
    int k=0;
     for(int j=0;j<12;j++){ //p cada face
          if(faces[j][0] == v1 || faces[j][1] == v1 || faces[j][2] == v1 || faces[j][3] == v1){
               if(faces[j][0] == v2 || faces[j][1] == v2 || faces[j][2] == v2 || faces[j][3] == v2){
                    arestaf[i][k] = j;
                    k++;
              }
          }
     }
     //printf("arestaf%i = ( %i , %i)\n",i,arestaf[i][0],arestaf[i][1]);
}


/****************************************************************/
//vertices-face
/****************************************************************/
for (int j = 0; j < 3; j++) {  // para cada coordenada

    for (int i = 0; i < 6; i++) { // para cada face
        
        GLfloat total = 0;
        for (int k = 0; k < 4; k++) {  // para cada vertice
            total = total + vertices[faces[i][k]][j];
        }
        total = total / 4;
        fv[i][j] = total;
    }
     
}

//desenha os vertices-face
for (int i = 0; i<6 ; i++){
    glPointSize(2.0);
    glBegin(GL_POINTS);
    glColor3f(1.0, 1.0, 1.0);
    glVertex3f(fv[i][0],fv[i][1],fv[i][2]);
    glEnd();
}


/****************************************************************/
//vertices-aresta
/****************************************************************/
GLfloat total1, total2, total = 0; 
for (int j = 0; j < 3; j++){ //pra cada coordenada

    for (int i = 0; i < 12; i++){ // pra cada aresta
       total1 = 0; total2 = 0; total = 0;
        
        //busca nas arestas
        for (int k = 0; k < 2; k++){
            total1 = total1 + vertices[arestas[i][k]][j];    
        }
        total1 = total1 / 2;
        
        //busca no vface(fv)
        for (int k = 0; k < 2; k++){
            total2 = total2 + fv[arestaf[i][k]][j];
        }
        total2 = total2 / 2;
        total = (total1 + total2)/2;
        ev[i][j] = total;
    }
    
}

//desenha os vertices-aresta
for (int i = 0; i<12 ; i++){
    glPointSize(2.0);
    glBegin(GL_POINTS);
    glColor3f(0.0, 1.0, 0.0);
    glVertex3f(ev[i][0],ev[i][1],ev[i][2]);
    glEnd();
}


/****************************************************************/
//vertices-vertice
/****************************************************************/
int faces_vizinhas[8][3]; //faces vizinhas
int arestas_vizinhas[8][3]; //arestas vizinhas

//busca os vertices vizinhos, pelas arestas
for (int i = 0;i<8;i++){ //p cada vertice
    int k = 0;
    for(int j=0;j<12;j++){ //p cada aresta
          if(arestas[j][0] == i || arestas[j][1] == i){
               if(arestas[j][0] == i){arestas_vizinhas[i][k] = arestas[j][1];}else{
               arestas_vizinhas[i][k] = arestas[j][0];}
               k++;
          }
    }
    //printf("va%i = ( %i , %i , %i )\n",i,arestas_vizinhas[i][0],arestas_vizinhas[i][1],arestas_vizinhas[i][2]); 
}

//busca as faces vizinhas
for (int i = 0;i<8;i++){ //p cada vertice
    int k = 0;
    for(int j=0;j<12;j++){ //p cada face
          if(faces[j][0] == i || faces[j][1] == i || faces[j][2] == i || faces[j][3] == i){
               faces_vizinhas[i][k] = j;
               k++;
          }
    }
    //printf("vf%i = ( %i , %i , %i )\n",i,faces_vizinhas[i][0],faces_vizinhas[i][1],faces_vizinhas[i][2]);
}

for (int j=0;j<3;j++){ // p cada coordenada

    for (int i=0;i<8;i++){ // p cada vertice
    
        vv[i][j]=(vertices[i][j]/3)*0+
                  (((fv[faces_vizinhas[i][0]][j]+fv[faces_vizinhas[i][1]][j]+fv[faces_vizinhas[i][2]][j])/3)/3)+
                  (2*(((vertices[i][j]+vertices[arestas_vizinhas[i][0]][j])/2+(vertices[i][j]+vertices[arestas_vizinhas[i][1]][j])/2+(vertices[i][j]+vertices[arestas_vizinhas[i][2]][j])/2)/3)/3);;
    }    
}

//desenha os vertices-vertice
for (int i = 0; i<8 ; i++){
    glPointSize(2.0);
    glBegin(GL_POINTS);
    glColor3f(1.0, 1.0, 0.0);
    glVertex3f(vv[i][0],vv[i][1],vv[i][2]);
    glEnd();
}




//monta as faces
aux = 0;
int arestas_validas[2];
for (int i=0; i<6; i++){ //p cada face
    
    for (int j=0;j<4;j++){ //p cada vertice original
        
            //busca as arestas vizinhas
            int k = 0;
            for(int l=0;l<12;l++){ //p cada aresta
                  if(arestas[l][0] == faces[i][j] || arestas[l][1] == faces[i][j]){
                       arestas_vizinhas[j][k] = l;
                       k++;
                  }
            }
//            printf("face%i = ( %i , %i , %i )\n",i,arestas_vizinhas[j][0],arestas_vizinhas[j][1],arestas_vizinhas[j][2]);
            
            int aux2=0;
            for (int k=0;k<3;k++) { //para cada aresta encontrada (3)
                //pega apenas as 2 que fazem parte desta face
                if(arestaf[arestas_vizinhas[j][k]][0]==i || arestaf[arestas_vizinhas[j][k]][1]==i){
                     arestas_validas[aux2] = arestas_vizinhas[j][k];
                     aux2++;
                 }
            }
//            printf("face%i = ( %i , %i )\n",i,arestas_validas[0],arestas_validas[1]);
            
            fint[aux][0] = i; //indice do vertice face
            fint[aux][1] = arestas_validas[0]; //indice do 1 vertice aresta
            fint[aux][2] = faces[i][j]; //indice do vertice vertice
            fint[aux][3] = arestas_validas[1]; //indice do 2 vertice aresta
//            printf("novaface%i = ( %i , %i, %i, %i )\n",aux,fint[aux][0],fint[aux][1],fint[aux][2],fint[aux][3]);
            aux ++;
    }
}


//transcreve os novos vertices para um vetor apenas
aux = 0;
for (int i=0; i<6; i++){// p cada vface
        vertices1[aux][0] = fv[i][0]; //transcreve as 3 coordenadas
        vertices1[aux][1] = fv[i][1];
        vertices1[aux][2] = fv[i][2];
        
        for (int k=0;k<24;k++){ //atualiza o vetor de faces com o novo indice
            if(fint[k][0] == i){faces1[k][0] = aux;} //indice 0 - vfaces
        }
        aux++;
}

for (int i=0; i<12; i++){// p cada vedge
        vertices1[aux][0] = ev[i][0]; //transcreve as 3 coordenadas
        vertices1[aux][1] = ev[i][1];
        vertices1[aux][2] = ev[i][2];
        
        for (int k=0;k<24;k++){ //atualiza o vetor de faces com o novo indice
            if(fint[k][1] == i){faces1[k][1] = aux;} //indice 1 - vedge
        }
        for (int k=0;k<24;k++){ //atualiza o vetor de faces com o novo indice
            if(fint[k][3] == i){faces1[k][3] = aux;} //indice 3 - vedge
        }
        aux++;
}

for (int i=0; i<8; i++){// p cada vvertex
        vertices1[aux][0] = vv[i][0]; //transcreve as 3 coordenadas
        vertices1[aux][1] = vv[i][1];
        vertices1[aux][2] = vv[i][2];
        
        for (int k=0;k<24;k++){ //atualiza o vetor de faces com o novo indice
            if(fint[k][2] == i){faces1[k][2] = aux;} //indice 2 - vvertex
        }
        aux++;
}


//for (int i=0;i<24;i++){
//    printf("novaface%i = ( %i , %i, %i, %i )\n",i,faces1[i][0],faces1[i][1],faces1[i][2],faces1[i][3]);
//}

}





/******************************************************************************
//SEGUNDA INTERACAO
******************************************************************************/

void cubo_interacao2()
{
GLfloat fv1[24][3] = { }; //face vertex
GLfloat ev1[48][3] = { }; //edge vertex
GLfloat vv1[26][3] = { }; // vertex vertex
GLint fint1[96][4] = { }; //faces interacao 1 com indices separados p/ fv, ev, vv
GLint arestas1[48][2] = { };// declaracao deve ser dentro da funcao
GLint arestaf1[48][2] = { };



//deriva a estrutura de arestas a partir das faces e dos vertices
int aux = 0;
for (int i=0; i<24;i++){ //p cada face
    for (int j=0; j<4;j++){ //p cada vertice de uma face (-1)
        int aux2 = 0;
        int aux1 = faces1[i][j];
        if (j==3){aux2 = faces1[i][0];}else{
        aux2 = faces1[i][j+1];}
        
        int flag = 0; //variavel q diz se existe associacao
        for (int k=0; k<=aux;k++){ //verifica se jah existe essa associacao
            if(arestas1[k][0] == aux1){
                if(arestas1[k][1] == aux2){flag = 1;}
            }
            if(arestas1[k][1] == aux1){
                if(arestas1[k][0] == aux2){flag = 1;}
            }
        }
        if (flag == 0){ //cria associacao
           arestas1[aux][0] = aux1;
           arestas1[aux][1] = aux2;
           //printf("arestas1-%i = ( %i , %i)\n",aux,arestas1[aux][0],arestas1[aux][1]);
           aux ++;
        }
    }
}


//deriva a estrutura de arestas baseadas em faces
for (int i=0;i<48;i++){ //p cada aresta pega os 2 vertices
    int v1 = arestas1[i][0]; 
    int v2 = arestas1[i][1];

    //busca as faces vizinhas
    int k=0;
     for(int j=0;j<24;j++){ //p cada face
          if(faces1[j][0] == v1 || faces1[j][1] == v1 || faces1[j][2] == v1 || faces1[j][3] == v1){
               if(faces1[j][0] == v2 || faces1[j][1] == v2 || faces1[j][2] == v2 || faces1[j][3] == v2){
                    arestaf1[i][k] = j;
                    k++;
              }
          }
     }
    //printf("arestaf1-%i = ( %i , %i)\n",i,arestaf1[i][0],arestaf1[i][1]);
}



//vertices-face
for (int j = 0; j < 3; j++) {  // para cada coordenada

    for (int i = 0; i < 24; i++) { // para cada face
        
        GLfloat total = 0;
        for (int k = 0; k < 4; k++) {  // para cada vertice
            total = total + vertices1[faces1[i][k]][j];
        }
        total = total / 4;
        fv1[i][j] = total;
    }
     
}

//desenha os vertices-face
for (int i = 0; i<24 ; i++){
    glPointSize(2.0);
    glBegin(GL_POINTS);
    glColor3f(1.0, 1.0, 1.0);
    glVertex3f(fv1[i][0],fv1[i][1],fv1[i][2]);
    glEnd();
}


//vertices-aresta
GLfloat total1, total2, total = 0; 
for (int j = 0; j < 3; j++){ //pra cada coordenada

    for (int i = 0; i < 48; i++){ // pra cada aresta
       total1 = 0; total2 = 0; total = 0;
        
        //busca nas arestas
        for (int k = 0; k < 2; k++){
            total1 = total1 + vertices1[arestas1[i][k]][j];    
        }
        total1 = total1 / 2;
        
        //busca no vface(fv)
        for (int k = 0; k < 2; k++){
            total2 = total2 + fv1[arestaf1[i][k]][j];
        }
        total2 = total2 / 2;
        total = (total1 + total2)/2;
        ev1[i][j] = total;
    }
    
}

//desenha os vertices-aresta
for (int i = 0; i<48 ; i++){
    glPointSize(2.0);
    glBegin(GL_POINTS);
    glColor3f(0.0, 1.0, 0.0);
    glVertex3f(ev1[i][0],ev1[i][1],ev1[i][2]);
    glEnd();
}


//vertices-vertice
int faces_vizinhas1[26][4]; //faces vizinhas
int arestas_vizinhas1[26][4]; //arestas vizinhas
for (int i = 0;i<26;i++){
    for(int j=0;j<4;j++){
          faces_vizinhas1[i][j] = -1;
          arestas_vizinhas1[i][j] = -1;          
    }
}


//busca os vertices vizinhos, pelas arestas
for (int i = 0;i<26;i++){ //p cada vertice
    int k = 0;
    for(int j=0;j<48;j++){ //p cada aresta
          if(arestas1[j][0] == i || arestas1[j][1] == i){
               if(arestas1[j][0] == i){arestas_vizinhas1[i][k] = arestas1[j][1];}else{
               arestas_vizinhas1[i][k] = arestas1[j][0];}
               k++;
          }
    }
    //printf("va%i = ( %i , %i , %i, %i )\n",i,arestas_vizinhas1[i][0],arestas_vizinhas1[i][1],arestas_vizinhas1[i][2],arestas_vizinhas1[i][3]); 
}

//busca as faces vizinhas
for (int i = 0;i<26;i++){ //p cada vertice
    int k = 0;
    for(int j=0;j<24;j++){ //p cada face
          if(faces1[j][0] == i || faces1[j][1] == i || faces1[j][2] == i || faces1[j][3] == i){
               faces_vizinhas1[i][k] = j;
               k++;
          }
    }
//    printf("vf%i = ( %i , %i , %i, %i )\n",i,faces_vizinhas1[i][0],faces_vizinhas1[i][1],faces_vizinhas1[i][2],faces_vizinhas1[i][3]);
}

for (int j=0;j<3;j++){ // p cada coordenada

    for (int i=0;i<26;i++){ // p cada vertice
    
        if (faces_vizinhas1[i][3] == -1){
            vv1[i][j]=(vertices1[i][j]/3)*0+
                      (((fv1[faces_vizinhas1[i][0]][j]+fv1[faces_vizinhas1[i][1]][j]+fv1[faces_vizinhas1[i][2]][j])/3)/3)+
                      (2*(((vertices1[i][j]+vertices1[arestas_vizinhas1[i][0]][j])/2+(vertices1[i][j]+vertices1[arestas_vizinhas1[i][1]][j])/2+(vertices1[i][j]+vertices1[arestas_vizinhas1[i][2]][j])/2)/3)/3);
        }else{
            vv1[i][j]=(vertices1[i][j]/4)+
                      (((fv1[faces_vizinhas1[i][0]][j]+fv1[faces_vizinhas1[i][1]][j]+fv1[faces_vizinhas1[i][2]][j]+fv1[faces_vizinhas1[i][3]][j])/4)/4)+
                      (2*(((vertices1[i][j]+vertices1[arestas_vizinhas1[i][0]][j])/2+(vertices1[i][j]+vertices1[arestas_vizinhas1[i][1]][j])/2+(vertices1[i][j]+vertices1[arestas_vizinhas1[i][2]][j])/2+(vertices1[i][j]+vertices1[arestas_vizinhas1[i][3]][j])/2)/4)/4);        
        }
    }    
}

//desenha os vertices-vertice
for (int i = 0; i<26 ; i++){
    glPointSize(2.0);
    glBegin(GL_POINTS);
    glColor3f(1.0, 1.0, 0.0);
    glVertex3f(vv1[i][0],vv1[i][1],vv1[i][2]);
    glEnd();
}



//monta as faces
aux = 0;
int arestas_validas1[2];
for (int i=0; i<24; i++){ //p cada face
    
    for (int j=0;j<4;j++){ //p cada vertice original
        
            //busca as arestas vizinhas
            int k = 0;
            for(int l=0;l<48;l++){ //p cada aresta
                  if(arestas1[l][0] == faces1[i][j] || arestas1[l][1] == faces1[i][j]){
                       arestas_vizinhas1[j][k] = l;
                       k++;
                  }
            }
//            printf("face%i = ( %i , %i , %i, %i )\n",i,arestas_vizinhas1[j][0],arestas_vizinhas1[j][1],arestas_vizinhas1[j][2],arestas_vizinhas1[j][3]);
            
            int aux2=0;
            for (int k=0;k<4;k++) { //para cada aresta encontrada (3)
                //pega apenas as 2 que fazem parte desta face
                if(arestaf1[arestas_vizinhas1[j][k]][0]==i || arestaf1[arestas_vizinhas1[j][k]][1]==i){
                     arestas_validas1[aux2] = arestas_vizinhas1[j][k];
                     aux2++;
                 }
            }
//            printf("face%i = ( %i , %i )\n",i,arestas_validas1[0],arestas_validas1[1]);
            
            fint1[aux][0] = i; //indice do vertice face
            fint1[aux][1] = arestas_validas1[0]; //indice do 1 vertice aresta
            fint1[aux][2] = faces1[i][j]; //indice do vertice vertice
            fint1[aux][3] = arestas_validas1[1]; //indice do 2 vertice aresta
//            printf("novaface%i = ( %i , %i, %i, %i )\n",aux,fint1[aux][0],fint1[aux][1],fint1[aux][2],fint1[aux][3]);

/*         
        glColor3f (1.0, 1.0, 1.0);   
        glBegin(GL_LINE_STRIP);
        glVertex3f(fv1[fint1[aux][0]][0],fv1[fint1[aux][0]][1],fv1[fint1[aux][0]][2]);
        glVertex3f(ev1[fint1[aux][1]][0],ev1[fint1[aux][1]][1],ev1[fint1[aux][1]][2]);
        glVertex3f(vv1[fint1[aux][2]][0],vv1[fint1[aux][2]][1],vv1[fint1[aux][2]][2]);
        glVertex3f(ev1[fint1[aux][3]][0],ev1[fint1[aux][3]][1],ev1[fint1[aux][3]][2]);
        glVertex3f(fv1[fint1[aux][0]][0],fv1[fint1[aux][0]][1],fv1[fint1[aux][0]][2]);
        glEnd(); 
*/            
            
            aux ++;
    }
}




//transcreve os novos vertices para um vetor apenas
aux = 0;
for (int i=0; i<24; i++){// p cada vface
        vertices2[aux][0] = fv1[i][0]; //transcreve as 3 coordenadas
        vertices2[aux][1] = fv1[i][1];
        vertices2[aux][2] = fv1[i][2];
        
        for (int k=0;k<96;k++){ //atualiza o vetor de faces com o novo indice
            if(fint1[k][0] == i){faces2[k][0] = aux;} //indice 0 - vfaces
        }
        aux++;
}

for (int i=0; i<48; i++){// p cada vedge
        vertices2[aux][0] = ev1[i][0]; //transcreve as 3 coordenadas
        vertices2[aux][1] = ev1[i][1];
        vertices2[aux][2] = ev1[i][2];
        
        for (int k=0;k<96;k++){ //atualiza o vetor de faces com o novo indice
            if(fint1[k][1] == i){faces2[k][1] = aux;} //indice 1 - vedge
        }
        for (int k=0;k<96;k++){ //atualiza o vetor de faces com o novo indice
            if(fint1[k][3] == i){faces2[k][3] = aux;} //indice 3 - vedge
        }
        aux++;
}

for (int i=0; i<26; i++){// p cada vvertex
        vertices2[aux][0] = vv1[i][0]; //transcreve as 3 coordenadas
        vertices2[aux][1] = vv1[i][1];
        vertices2[aux][2] = vv1[i][2];
        
        for (int k=0;k<96;k++){ //atualiza o vetor de faces com o novo indice
            if(fint1[k][2] == i){faces2[k][2] = aux;} //indice 2 - vvertex
        }
        aux++;
}


//for (int i=0;i<96;i++){
//    printf("novaface%i = ( %i , %i, %i, %i )\n",i,faces2[i][0],faces2[i][1],faces2[i][2],faces2[i][3]);
//}


}






/******************************************************************************
//TERCEIRA INTERACAO
******************************************************************************/


void cubo_interacao3()
{
GLfloat fv2[96][3] = { }; //face vertex
GLfloat ev2[192][3] = { }; //edge vertex
GLfloat vv2[98][3] = { }; // vertex vertex
GLint fint2[384][4] = { }; //faces interacao 1 com indices separados p/ fv, ev, vv
GLint arestas2[192][2] = { };// declaracao deve ser dentro da funcao
GLint arestaf2[192][2] = { };



//deriva a estrutura de arestas a partir das faces e dos vertices
int aux = 0;
for (int i=0; i<96;i++){ //p cada face
    for (int j=0; j<4;j++){ //p cada vertice de uma face (-1)
        int aux2 = 0;
        int aux1 = faces2[i][j];
        if (j==3){aux2 = faces2[i][0];}else{
        aux2 = faces2[i][j+1];}
        
        int flag = 0; //variavel q diz se existe associacao
        for (int k=0; k<=aux;k++){ //verifica se jah existe essa associacao
            if(arestas2[k][0] == aux1){
                if(arestas2[k][1] == aux2){flag = 1;}
            }
            if(arestas2[k][1] == aux1){
                if(arestas2[k][0] == aux2){flag = 1;}
            }
        }
        if (flag == 0){ //cria associacao
           arestas2[aux][0] = aux1;
           arestas2[aux][1] = aux2;
           //printf("arestas1-%i = ( %i , %i)\n",aux,arestas2[aux][0],arestas2[aux][1]);
           aux ++;
        }
    }
}


//deriva a estrutura de arestas baseadas em faces
for (int i=0;i<192;i++){ //p cada aresta pega os 2 vertices
    int v1 = arestas2[i][0]; 
    int v2 = arestas2[i][1];

    //busca as faces vizinhas
    int k=0;
     for(int j=0;j<96;j++){ //p cada face
          if(faces2[j][0] == v1 || faces2[j][1] == v1 || faces2[j][2] == v1 || faces2[j][3] == v1){
               if(faces2[j][0] == v2 || faces2[j][1] == v2 || faces2[j][2] == v2 || faces2[j][3] == v2){
                    arestaf2[i][k] = j;
                    k++;
              }
          }
     }
//    printf("arestaf2-%i = ( %i , %i)\n",i,arestaf2[i][0],arestaf2[i][1]);
}



//vertices-face
for (int j = 0; j < 3; j++) {  // para cada coordenada

    for (int i = 0; i < 96; i++) { // para cada face
        
        GLfloat total = 0;
        for (int k = 0; k < 4; k++) {  // para cada vertice
            total = total + vertices2[faces2[i][k]][j];
        }
        total = total / 4;
        fv2[i][j] = total;
    }
     
}

//desenha os vertices-face
for (int i = 0; i<96 ; i++){
    glPointSize(2.0);
    glBegin(GL_POINTS);
    glColor3f(1.0, 1.0, 1.0);
    glVertex3f(fv2[i][0],fv2[i][1],fv2[i][2]);
    glEnd();
}


//vertices-aresta
GLfloat total1, total2, total = 0; 
for (int j = 0; j < 3; j++){ //pra cada coordenada

    for (int i = 0; i < 192; i++){ // pra cada aresta
       total1 = 0; total2 = 0; total = 0;
        
        //busca nas arestas
        for (int k = 0; k < 2; k++){
            total1 = total1 + vertices2[arestas2[i][k]][j];    
        }
        total1 = total1 / 2;
        
        //busca no vface(fv)
        for (int k = 0; k < 2; k++){
            total2 = total2 + fv2[arestaf2[i][k]][j];
        }
        total2 = total2 / 2;
        total = (total1 + total2)/2;
        ev2[i][j] = total;
    }
    
}

//desenha os vertices-aresta
for (int i = 0; i<192 ; i++){
    glPointSize(2.0);
    glBegin(GL_POINTS);
    glColor3f(0.0, 1.0, 0.0);
    glVertex3f(ev2[i][0],ev2[i][1],ev2[i][2]);
    glEnd();
}


//vertices-vertice
int faces_vizinhas2[98][4]; //faces vizinhas
int arestas_vizinhas2[98][4]; //arestas vizinhas
for (int i = 0;i<98;i++){
    for(int j=0;j<4;j++){
          faces_vizinhas2[i][j] = -1;
          arestas_vizinhas2[i][j] = -1;          
    }
}


//busca os vertices vizinhos, pelas arestas
for (int i = 0;i<98;i++){ //p cada vertice
    int k = 0;
    for(int j=0;j<192;j++){ //p cada aresta
          if(arestas2[j][0] == i || arestas2[j][1] == i){
               if(arestas2[j][0] == i){arestas_vizinhas2[i][k] = arestas2[j][1];}else{
               arestas_vizinhas2[i][k] = arestas2[j][0];}
               k++;
          }
    }
//    printf("va%i = ( %i , %i , %i, %i )\n",i,arestas_vizinhas2[i][0],arestas_vizinhas2[i][1],arestas_vizinhas2[i][2],arestas_vizinhas2[i][3]); 
}

//busca as faces vizinhas
for (int i = 0;i<98;i++){ //p cada vertice
    int k = 0;
    for(int j=0;j<96;j++){ //p cada face
          if(faces2[j][0] == i || faces2[j][1] == i || faces2[j][2] == i || faces2[j][3] == i){
               faces_vizinhas2[i][k] = j;
               k++;
          }
    }
//    printf("vf%i = ( %i , %i , %i, %i )\n",i,faces_vizinhas2[i][0],faces_vizinhas2[i][1],faces_vizinhas2[i][2],faces_vizinhas2[i][3]);
}

for (int j=0;j<3;j++){ // p cada coordenada

    for (int i=0;i<98;i++){ // p cada vertice
    
        if (faces_vizinhas2[i][3] == -1){
            vv2[i][j]=(vertices2[i][j]/3)*0+
                      (((fv2[faces_vizinhas2[i][0]][j]+fv2[faces_vizinhas2[i][1]][j]+fv2[faces_vizinhas2[i][2]][j])/3)/3)+
                      (2*(((vertices2[i][j]+vertices2[arestas_vizinhas2[i][0]][j])/2+(vertices2[i][j]+vertices2[arestas_vizinhas2[i][1]][j])/2+(vertices2[i][j]+vertices2[arestas_vizinhas2[i][2]][j])/2)/3)/3);
        }else{
            vv2[i][j]=(vertices2[i][j]/4)+
                      (((fv2[faces_vizinhas2[i][0]][j]+fv2[faces_vizinhas2[i][1]][j]+fv2[faces_vizinhas2[i][2]][j]+fv2[faces_vizinhas2[i][3]][j])/4)/4)+
                      (2*(((vertices2[i][j]+vertices2[arestas_vizinhas2[i][0]][j])/2+(vertices2[i][j]+vertices2[arestas_vizinhas2[i][1]][j])/2+(vertices2[i][j]+vertices2[arestas_vizinhas2[i][2]][j])/2+(vertices2[i][j]+vertices2[arestas_vizinhas2[i][3]][j])/2)/4)/4);        
        }
    }    
}

//desenha os vertices-vertice
for (int i = 0; i<98 ; i++){
    glPointSize(2.0);
    glBegin(GL_POINTS);
    glColor3f(1.0, 1.0, 0.0);
    glVertex3f(vv2[i][0],vv2[i][1],vv2[i][2]);
    glEnd();
}



//monta as faces
aux = 0;
int arestas_validas2[2];
for (int i=0; i<96; i++){ //p cada face
    
    for (int j=0;j<4;j++){ //p cada vertice original
        
            //busca as arestas vizinhas
            int k = 0;
            for(int l=0;l<192;l++){ //p cada aresta
                  if(arestas2[l][0] == faces2[i][j] || arestas2[l][1] == faces2[i][j]){
                       arestas_vizinhas2[j][k] = l;
                       k++;
                  }
            }
//            printf("face%i = ( %i , %i , %i, %i )\n",i,arestas_vizinhas2[j][0],arestas_vizinhas2[j][1],arestas_vizinhas2[j][2],arestas_vizinhas2[j][3]);
            
            int aux2=0;
            for (int k=0;k<4;k++) { //para cada aresta encontrada (3 a 4)
                //pega apenas as 2 que fazem parte desta face
                if(arestaf2[arestas_vizinhas2[j][k]][0]==i || arestaf2[arestas_vizinhas2[j][k]][1]==i){
                     arestas_validas2[aux2] = arestas_vizinhas2[j][k];
                     aux2++;
                 }
            }
//            printf("face%i = ( %i , %i )\n",i,arestas_validas2[0],arestas_validas2[1]);
            
            fint2[aux][0] = i; //indice do vertice face
            fint2[aux][1] = arestas_validas2[0]; //indice do 1 vertice aresta
            fint2[aux][2] = faces2[i][j]; //indice do vertice vertice
            fint2[aux][3] = arestas_validas2[1]; //indice do 2 vertice aresta
        //    printf("novaface%i = ( %i , %i, %i, %i )\n",aux,fint2[aux][0],fint2[aux][1],fint2[aux][2],fint2[aux][3]);

         
      /* glColor3f (1.0, 1.0, 1.0);   
        glBegin(GL_LINE_STRIP);
        glVertex3f(fv2[fint2[aux][0]][0],fv2[fint2[aux][0]][1],fv2[fint2[aux][0]][2]);
        glVertex3f(ev2[fint2[aux][1]][0],ev2[fint2[aux][1]][1],ev2[fint2[aux][1]][2]);
        glVertex3f(vv2[fint2[aux][2]][0],vv2[fint2[aux][2]][1],vv2[fint2[aux][2]][2]);
        glVertex3f(ev2[fint2[aux][3]][0],ev2[fint2[aux][3]][1],ev2[fint2[aux][3]][2]);
        glVertex3f(fv2[fint2[aux][0]][0],fv2[fint2[aux][0]][1],fv2[fint2[aux][0]][2]);
        glEnd(); 
        */
            
            aux ++;
    }
}

for(int i=0;i<384;i++){
        for(int j=0;j<4;j++){
                faces3[i][j]=-1;}}

//for (int i=0;i<10;i++){
//    printf("novaface%i = ( %i , %i, %i, %i )\n",i,faces3[i][0],faces3[i][1],faces3[i][2],faces3[i][3]);
//}

//transcreve os novos vertices para um vetor apenas
aux = 0;
for (int i=0; i<96; i++){// p cada vface
        vertices3[aux][0] = fv2[i][0]; //transcreve as 3 coordenadas
        vertices3[aux][1] = fv2[i][1];
        vertices3[aux][2] = fv2[i][2];
        
        for (int k=0;k<384;k++){ //atualiza o vetor de faces com o novo indice
            if(fint2[k][0] == i){faces3[k][0] = aux;} //indice 0 - vfaces
        }
        aux++;
}

for (int i=0; i<192; i++){// p cada vedge
        vertices3[aux][0] = ev2[i][0]; //transcreve as 3 coordenadas
        vertices3[aux][1] = ev2[i][1];
        vertices3[aux][2] = ev2[i][2];
        
        for (int k=0;k<384;k++){ //atualiza o vetor de faces com o novo indice
            if(fint2[k][1] == i){faces3[k][1] = aux;} //indice 1 - vedge
        }
        for (int k=0;k<384;k++){ //atualiza o vetor de faces com o novo indice
            if(fint2[k][3] == i){faces3[k][3] = aux;} //indice 3 - vedge
        }
        aux++;
}

for (int i=0; i<98; i++){// p cada vvertex
        vertices3[aux][0] = vv2[i][0]; //transcreve as 3 coordenadas
        vertices3[aux][1] = vv2[i][1];
        vertices3[aux][2] = vv2[i][2];
        
        for (int k=0;k<384;k++){ //atualiza o vetor de faces com o novo indice
            if(fint2[k][2] == i){faces3[k][2] = aux;} //indice 2 - vvertex
        }
        aux++;
}


//for (int i=0;i<10;i++){
//    printf("novaface%i = ( %i , %i, %i, %i )\n",i,faces3[i][0],faces3[i][1],faces3[i][2],faces3[i][3]);
//}



}




/****************************************************************/
//CONSTRI tetraedro - 1a interacao
/****************************************************************/

void tetraedro_interacao1()
{
GLfloat tetfv[4][3] = { }; //face vertex
GLfloat tetev[6][3] = { }; //edge vertex
GLfloat tetvv[4][3] = { }; // vertex vertex
GLint tetfint[12][4] = { }; //faces interacao 1 com indices separados p/ fv, ev, vv
GLint tetarestas[6][2] = { };// declaracao deve ser dentro da funcao
GLint tetarestaf[6][2] = { };



//deriva a estrutura de arestas a partir das faces e dos vertices
int aux = 0;
for (int i=0; i<4;i++){ //p cada face
    for (int j=0; j<3;j++){ //p cada vertice de uma face (-1)
        int aux2 = 0;
        int aux1 = tetfaces[i][j];
        if (j==2){aux2 = tetfaces[i][0];}else{
        aux2 = tetfaces[i][j+1];}
        
        int flag = 0; //variavel q diz se existe associacao
        for (int k=0; k<=aux;k++){ //verifica se jah existe essa associacao
            if(tetarestas[k][0] == aux1){
                if(tetarestas[k][1] == aux2){flag = 1;}
            }
            if(tetarestas[k][1] == aux1){
                if(tetarestas[k][0] == aux2){flag = 1;}
            }
        }
        if (flag == 0){ //cria associacao
           tetarestas[aux][0] = aux1;
           tetarestas[aux][1] = aux2;
           //printf("arestas-%i = ( %i , %i)\n",aux,tetarestas[aux][0],tetarestas[aux][1]);
           aux ++;
        }
    }
}


//deriva a estrutura de arestas baseadas em faces
for (int i=0;i<6;i++){ //p cada aresta pega os 2 vertices
    int v1 = tetarestas[i][0]; 
    int v2 = tetarestas[i][1];

    //busca as faces vizinhas
    int k=0;
     for(int j=0;j<4;j++){ //p cada face
          if(tetfaces[j][0] == v1 || tetfaces[j][1] == v1 || tetfaces[j][2] == v1){
               if(tetfaces[j][0] == v2 || tetfaces[j][1] == v2 || tetfaces[j][2] == v2){
                    tetarestaf[i][k] = j;
                    k++;
              }
          }
     }
    //printf("arestaf-%i = ( %i , %i)\n",i,tetarestaf[i][0],tetarestaf[i][1]);
}



//vertices-face
for (int j = 0; j < 3; j++) {  // para cada coordenada

    for (int i = 0; i < 4; i++) { // para cada face
        
        GLfloat total = 0;
        for (int k = 0; k < 3; k++) {  // para cada vertice
            total = total + tetvertices[tetfaces[i][k]][j];
        }
        total = total / 3;
        tetfv[i][j] = total;
    }
     
}

//desenha os vertices-face
for (int i = 0; i<4 ; i++){
    glPointSize(2.0);
    glBegin(GL_POINTS);
    glColor3f(1.0, 1.0, 1.0);
    glVertex3f(tetfv[i][0],tetfv[i][1],tetfv[i][2]);
    glEnd();
}


//vertices-aresta
GLfloat total1, total2, total = 0; 
for (int j = 0; j < 3; j++){ //pra cada coordenada

    for (int i = 0; i < 6; i++){ // pra cada aresta
       total1 = 0; total2 = 0; total = 0;
        
        //busca nas arestas
        for (int k = 0; k < 2; k++){
            total1 = total1 + tetvertices[tetarestas[i][k]][j];    
        }
        total1 = total1 / 2;
        
        //busca no vface(fv)
        for (int k = 0; k < 2; k++){
            total2 = total2 + tetfv[tetarestaf[i][k]][j];
        }
        total2 = total2 / 2;
        total = (total1 + total2)/2;
        tetev[i][j] = total;
    }
    
}

//desenha os vertices-aresta
for (int i = 0; i<6 ; i++){
    glPointSize(2.0);
    glBegin(GL_POINTS);
    glColor3f(0.0, 1.0, 0.0);
    glVertex3f(tetev[i][0],tetev[i][1],tetev[i][2]);
    glEnd();
}


//vertices-vertice
int tetfaces_vizinhas[4][3]; //faces vizinhas
int tetarestas_vizinhas[4][3]; //arestas vizinhas
for (int i = 0;i<4;i++){
    for(int j=0;j<3;j++){
          tetfaces_vizinhas[i][j] = -1;
          tetarestas_vizinhas[i][j] = -1;          
    }
}


//busca os vertices vizinhos, pelas arestas
for (int i = 0;i<4;i++){ //p cada vertice
    int k = 0;
    for(int j=0;j<6;j++){ //p cada aresta
          if(tetarestas[j][0] == i || tetarestas[j][1] == i){
               if(tetarestas[j][0] == i){tetarestas_vizinhas[i][k] = tetarestas[j][1];}else{
               tetarestas_vizinhas[i][k] = tetarestas[j][0];}
               k++;
          }
    }
//    printf("va%i = ( %i , %i , %i)\n",i,tetarestas_vizinhas[i][0],tetarestas_vizinhas[i][1],tetarestas_vizinhas[i][2]); 
}

//busca as faces vizinhas
for (int i = 0;i<4;i++){ //p cada vertice
    int k = 0;
    for(int j=0;j<4;j++){ //p cada face
          if(tetfaces[j][0] == i || tetfaces[j][1] == i || tetfaces[j][2] == i){
               tetfaces_vizinhas[i][k] = j;
               k++;
          }
    }
    //printf("vf%i = ( %i , %i , %i)\n",i,tetfaces_vizinhas[i][0],tetfaces_vizinhas[i][1],tetfaces_vizinhas[i][2]);
}

for (int j=0;j<3;j++){ // p cada coordenada

    for (int i=0;i<4;i++){ // p cada vertice
    
            tetvv[i][j]=(tetvertices[i][j]/3)*0+
                      (((tetfv[tetfaces_vizinhas[i][0]][j]+tetfv[tetfaces_vizinhas[i][1]][j]+tetfv[tetfaces_vizinhas[i][2]][j])/3)/3)+
                      (2*(((tetvertices[i][j]+tetvertices[tetarestas_vizinhas[i][0]][j])/2+(tetvertices[i][j]+tetvertices[tetarestas_vizinhas[i][1]][j])/2+(tetvertices[i][j]+tetvertices[tetarestas_vizinhas[i][2]][j])/2)/3)/3);
    }    
}


//desenha os vertices-vertice
for (int i = 0; i<6 ; i++){
    glPointSize(2.0);
    glBegin(GL_POINTS);
    glColor3f(1.0, 1.0, 0.0);
//    printf("vv%i = ( %i , %i , %i)\n",i,tetvv[i][0],tetvv[i][1],tetvv[i][2]);
    glVertex3f(tetvv[i][0],tetvv[i][1],tetvv[i][2]);
    glEnd();
}


//monta as faces
aux = 0;
int tetarestas_validas[2];
for (int i=0; i<4; i++){ //p cada face
    
    for (int j=0;j<3;j++){ //p cada vertice original
        
            //busca as arestas vizinhas
            int k = 0;
            for(int l=0;l<6;l++){ //p cada aresta
                  if(tetarestas[l][0] == tetfaces[i][j] || tetarestas[l][1] == tetfaces[i][j]){
                       tetarestas_vizinhas[j][k] = l;
                       k++;
                  }
            }
//            printf("face%i = ( %i , %i , %i )\n",i,tetarestas_vizinhas[j][0],tetarestas_vizinhas[j][1],tetarestas_vizinhas[j][2]);
            
            int aux2=0;
            for (int k=0;k<3;k++) { //para cada aresta encontrada (3)
                //pega apenas as 2 que fazem parte desta face
                if(tetarestaf[tetarestas_vizinhas[j][k]][0]==i || tetarestaf[tetarestas_vizinhas[j][k]][1]==i){
                     tetarestas_validas[aux2] = tetarestas_vizinhas[j][k];
                     aux2++;
                 }
            }
//            printf("face%i = ( %i , %i )\n",i,tetarestas_validas[0],tetarestas_validas[1]);
            
            tetfint[aux][0] = i; //indice do vertice face
            tetfint[aux][1] = tetarestas_validas[0]; //indice do 1 vertice aresta
            tetfint[aux][2] = tetfaces[i][j]; //indice do vertice vertice
            tetfint[aux][3] = tetarestas_validas[1]; //indice do 2 vertice aresta
//            printf("novaface%i = ( %i , %i, %i, %i )\n",aux,tetfint[aux][0],tetfint[aux][1],tetfint[aux][2],tetfint[aux][3]);

       
/*        glColor3f (1.0, 1.0, 1.0);   
        glBegin(GL_LINE_STRIP);
        glVertex3f(tetfv[tetfint[aux][0]][0],tetfv[tetfint[aux][0]][1],tetfv[tetfint[aux][0]][2]);
        glVertex3f(tetev[tetfint[aux][1]][0],tetev[tetfint[aux][1]][1],tetev[tetfint[aux][1]][2]);
        glVertex3f(tetvv[tetfint[aux][2]][0],tetvv[tetfint[aux][2]][1],tetvv[tetfint[aux][2]][2]);
        glVertex3f(tetev[tetfint[aux][3]][0],tetev[tetfint[aux][3]][1],tetev[tetfint[aux][3]][2]);
        glVertex3f(tetfv[tetfint[aux][0]][0],tetfv[tetfint[aux][0]][1],tetfv[tetfint[aux][0]][2]);
        glEnd(); 
*/            
            
            aux ++;
    }
}




//transcreve os novos vertices para um vetor apenas
aux = 0;
for (int i=0; i<4; i++){// p cada vface
        tetvertices1[aux][0] = tetfv[i][0]; //transcreve as 3 coordenadas
        tetvertices1[aux][1] = tetfv[i][1];
        tetvertices1[aux][2] = tetfv[i][2];
        
        for (int k=0;k<12;k++){ //atualiza o vetor de faces com o novo indice
            if(tetfint[k][0] == i){tetfaces1[k][0] = aux;} //indice 0 - vfaces
        }
        aux++;
}

for (int i=0; i<6; i++){// p cada vedge
        tetvertices1[aux][0] = tetev[i][0]; //transcreve as 3 coordenadas
        tetvertices1[aux][1] = tetev[i][1];
        tetvertices1[aux][2] = tetev[i][2];
        
        for (int k=0;k<12;k++){ //atualiza o vetor de faces com o novo indice
            if(tetfint[k][1] == i){tetfaces1[k][1] = aux;} //indice 1 - vedge
        }
        for (int k=0;k<12;k++){ //atualiza o vetor de faces com o novo indice
            if(tetfint[k][3] == i){tetfaces1[k][3] = aux;} //indice 3 - vedge
        }
        aux++;
}

for (int i=0; i<4; i++){// p cada vvertex
        tetvertices1[aux][0] = tetvv[i][0]; //transcreve as 3 coordenadas
        tetvertices1[aux][1] = tetvv[i][1];
        tetvertices1[aux][2] = tetvv[i][2];
        
        for (int k=0;k<12;k++){ //atualiza o vetor de faces com o novo indice
            if(tetfint[k][2] == i){tetfaces1[k][2] = aux;} //indice 2 - vvertex
        }
        aux++;
}


//for (int i=0;i<12;i++){
//    printf("novaface%i = ( %i , %i, %i, %i )\n",i,tetfaces1[i][0],tetfaces1[i][1],tetfaces1[i][2],tetfaces1[i][3]);
//}

//desenha o solido com os novos vetores de faces e vertices


}   





/******************************************************************************
//SEGUNDA INTERACAO
******************************************************************************/
void tetraedro_interacao2()
{
GLfloat tetfv1[12][3] = { }; //face vertex
GLfloat tetev1[24][3] = { }; //edge vertex
GLfloat tetvv1[14][3] = { }; // vertex vertex
GLint tetfint1[48][4] = { }; //faces interacao 1 com indices separados p/ fv, ev, vv
GLint tetarestas1[24][2] = { };// declaracao deve ser dentro da funcao
GLint tetarestaf1[24][2] = { };



//deriva a estrutura de arestas a partir das faces e dos vertices
int aux = 0;
for (int i=0; i<12;i++){ //p cada face
    for (int j=0; j<4;j++){ //p cada vertice de uma face (-1)
        int aux2 = 0;
        int aux1 = tetfaces1[i][j];
        if (j==3){aux2 = tetfaces1[i][0];}else{
        aux2 = tetfaces1[i][j+1];}
        
        int flag = 0; //variavel q diz se existe associacao
        for (int k=0; k<=aux;k++){ //verifica se jah existe essa associacao
            if(tetarestas1[k][0] == aux1){
                if(tetarestas1[k][1] == aux2){flag = 1;}
            }
            if(tetarestas1[k][1] == aux1){
                if(tetarestas1[k][0] == aux2){flag = 1;}
            }
        }
        if (flag == 0){ //cria associacao
           tetarestas1[aux][0] = aux1;
           tetarestas1[aux][1] = aux2;
           //printf("arestas1-%i = ( %i , %i)\n",aux,tetarestas1[aux][0],tetarestas1[aux][1]);
           aux ++;
        }
    }
}


//deriva a estrutura de arestas baseadas em faces
for (int i=0;i<24;i++){ //p cada aresta pega os 2 vertices
    int v1 = tetarestas1[i][0]; 
    int v2 = tetarestas1[i][1];

    //busca as faces vizinhas
    int k=0;
     for(int j=0;j<12;j++){ //p cada face
          if(tetfaces1[j][0] == v1 || tetfaces1[j][1] == v1 || tetfaces1[j][2] == v1 || tetfaces1[j][3] == v1){
               if(tetfaces1[j][0] == v2 || tetfaces1[j][1] == v2 || tetfaces1[j][2] == v2 || tetfaces1[j][3] == v2){
                    tetarestaf1[i][k] = j;
                    k++;
              }
          }
     }
//    printf("arestaf1-%i = ( %i , %i)\n",i,tetarestaf1[i][0],tetarestaf1[i][1]);
}



//vertices-face
for (int j = 0; j < 3; j++) {  // para cada coordenada

    for (int i = 0; i < 12; i++) { // para cada face
        
        GLfloat total = 0;
        for (int k = 0; k < 4; k++) {  // para cada vertice
            total = total + tetvertices1[tetfaces1[i][k]][j];
        }
        total = total / 4;
        tetfv1[i][j] = total;
    }
     
}

//desenha os vertices-face
for (int i = 0; i<12 ; i++){
    glPointSize(2.0);
    glBegin(GL_POINTS);
    glColor3f(1.0, 1.0, 1.0);
    glVertex3f(tetfv1[i][0],tetfv1[i][1],tetfv1[i][2]);
    glEnd();
}


//vertices-aresta
GLfloat total1, total2, total = 0; 
for (int j = 0; j < 3; j++){ //pra cada coordenada

    for (int i = 0; i < 24; i++){ // pra cada aresta
       total1 = 0; total2 = 0; total = 0;
        
        //busca nas arestas
        for (int k = 0; k < 2; k++){
            total1 = total1 + tetvertices1[tetarestas1[i][k]][j];    
        }
        total1 = total1 / 2;
        
        //busca no vface(fv)
        for (int k = 0; k < 2; k++){
            total2 = total2 + tetfv1[tetarestaf1[i][k]][j];
        }
        total2 = total2 / 2;
        total = (total1 + total2)/2;
        tetev1[i][j] = total;
    }
    
}

//desenha os vertices-aresta
for (int i = 0; i<24 ; i++){
    glPointSize(2.0);
    glBegin(GL_POINTS);
    glColor3f(0.0, 1.0, 0.0);
    glVertex3f(tetev1[i][0],tetev1[i][1],tetev1[i][2]);
    glEnd();
}


//vertices-vertice
int tetfaces_vizinhas1[14][4]; //faces vizinhas
int tetarestas_vizinhas1[14][4]; //arestas vizinhas
for (int i = 0;i<14;i++){
    for(int j=0;j<4;j++){
          tetfaces_vizinhas1[i][j] = -1;
          tetarestas_vizinhas1[i][j] = -1;          
    }
}


//busca os vertices vizinhos, pelas arestas
for (int i = 0;i<14;i++){ //p cada vertice
    int k = 0;
    for(int j=0;j<24;j++){ //p cada aresta
          if(tetarestas1[j][0] == i || tetarestas1[j][1] == i){
               if(tetarestas1[j][0] == i){tetarestas_vizinhas1[i][k] = tetarestas1[j][1];}else{
               tetarestas_vizinhas1[i][k] = tetarestas1[j][0];}
               k++;
          }
    }
//    printf("va%i = ( %i , %i , %i, %i )\n",i,tetarestas_vizinhas1[i][0],tetarestas_vizinhas1[i][1],tetarestas_vizinhas1[i][2],tetarestas_vizinhas1[i][3]); 
}

//busca as faces vizinhas
for (int i = 0;i<14;i++){ //p cada vertice
    int k = 0;
    for(int j=0;j<12;j++){ //p cada face
          if(tetfaces1[j][0] == i || tetfaces1[j][1] == i || tetfaces1[j][2] == i || tetfaces1[j][3] == i){
               tetfaces_vizinhas1[i][k] = j;
               k++;
          }
    }
//    printf("vf%i = ( %i , %i , %i, %i )\n",i,tetfaces_vizinhas1[i][0],tetfaces_vizinhas1[i][1],tetfaces_vizinhas1[i][2],tetfaces_vizinhas1[i][3]);
}

for (int j=0;j<3;j++){ // p cada coordenada

    for (int i=0;i<14;i++){ // p cada vertice
    
        if (tetfaces_vizinhas1[i][3] == -1){
            tetvv1[i][j]=(tetvertices1[i][j]/3)*0+
                      (((tetfv1[tetfaces_vizinhas1[i][0]][j]+tetfv1[tetfaces_vizinhas1[i][1]][j]+tetfv1[tetfaces_vizinhas1[i][2]][j])/3)/3)+
                      (2*(((tetvertices1[i][j]+tetvertices1[tetarestas_vizinhas1[i][0]][j])/2+(tetvertices1[i][j]+tetvertices1[tetarestas_vizinhas1[i][1]][j])/2+(tetvertices1[i][j]+tetvertices1[tetarestas_vizinhas1[i][2]][j])/2)/3)/3);
        }else{
            tetvv1[i][j]=(tetvertices1[i][j]/4)+
                      (((tetfv1[tetfaces_vizinhas1[i][0]][j]+tetfv1[tetfaces_vizinhas1[i][1]][j]+tetfv1[tetfaces_vizinhas1[i][2]][j]+tetfv1[tetfaces_vizinhas1[i][3]][j])/4)/4)+
                      (2*(((tetvertices1[i][j]+tetvertices1[tetarestas_vizinhas1[i][0]][j])/2+(tetvertices1[i][j]+tetvertices1[tetarestas_vizinhas1[i][1]][j])/2+(tetvertices1[i][j]+tetvertices1[tetarestas_vizinhas1[i][2]][j])/2+(tetvertices1[i][j]+tetvertices1[tetarestas_vizinhas1[i][3]][j])/2)/4)/4);        
        }
    }    
}

//desenha os vertices-vertice
for (int i = 0; i<14 ; i++){
    glPointSize(2.0);
    glBegin(GL_POINTS);
    glColor3f(1.0, 1.0, 0.0);
    glVertex3f(tetvv1[i][0],tetvv1[i][1],tetvv1[i][2]);
    glEnd();
}



//monta as faces
aux = 0;
int tetarestas_validas1[2];
for (int i=0; i<12; i++){ //p cada face
    
    for (int j=0;j<4;j++){ //p cada vertice original
        
            //busca as arestas vizinhas
            int k = 0;
            for(int l=0;l<24;l++){ //p cada aresta
                  if(tetarestas1[l][0] == tetfaces1[i][j] || tetarestas1[l][1] == tetfaces1[i][j]){
                       tetarestas_vizinhas1[j][k] = l;
                       k++;
                  }
            }
//            printf("face%i = ( %i , %i , %i, %i )\n",i,tetarestas_vizinhas1[j][0],tetarestas_vizinhas1[j][1],tetarestas_vizinhas1[j][2],tetarestas_vizinhas1[j][3]);
            
            int aux2=0;
            for (int k=0;k<4;k++) { //para cada aresta encontrada (3)
                //pega apenas as 2 que fazem parte desta face
                if(tetarestaf1[tetarestas_vizinhas1[j][k]][0]==i || tetarestaf1[tetarestas_vizinhas1[j][k]][1]==i){
                     tetarestas_validas1[aux2] = tetarestas_vizinhas1[j][k];
                     aux2++;
                 }
            }
//            printf("face%i = ( %i , %i )\n",i,tetarestas_validas1[0],tetarestas_validas1[1]);
            
            tetfint1[aux][0] = i; //indice do vertice face
            tetfint1[aux][1] = tetarestas_validas1[0]; //indice do 1 vertice aresta
            tetfint1[aux][2] = tetfaces1[i][j]; //indice do vertice vertice
            tetfint1[aux][3] = tetarestas_validas1[1]; //indice do 2 vertice aresta
//            printf("novaface%i = ( %i , %i, %i, %i )\n",aux,tetfint1[aux][0],tetfint1[aux][1],tetfint1[aux][2],tetfint1[aux][3]);

        
/*        glColor3f (1.0, 1.0, 1.0);   
        glBegin(GL_LINE_STRIP);
        glVertex3f(tetfv1[tetfint1[aux][0]][0],tetfv1[tetfint1[aux][0]][1],tetfv1[tetfint1[aux][0]][2]);
        glVertex3f(tetev1[tetfint1[aux][1]][0],tetev1[tetfint1[aux][1]][1],tetev1[tetfint1[aux][1]][2]);
        glVertex3f(tetvv1[tetfint1[aux][2]][0],tetvv1[tetfint1[aux][2]][1],tetvv1[tetfint1[aux][2]][2]);
        glVertex3f(tetev1[tetfint1[aux][3]][0],tetev1[tetfint1[aux][3]][1],tetev1[tetfint1[aux][3]][2]);
        glVertex3f(tetfv1[tetfint1[aux][0]][0],tetfv1[tetfint1[aux][0]][1],tetfv1[tetfint1[aux][0]][2]);
        glEnd(); 
*/            
            
            aux ++;
    }
}




//transcreve os novos vertices para um vetor apenas
aux = 0;
for (int i=0; i<12; i++){// p cada vface
        tetvertices2[aux][0] = tetfv1[i][0]; //transcreve as 3 coordenadas
        tetvertices2[aux][1] = tetfv1[i][1];
        tetvertices2[aux][2] = tetfv1[i][2];
        
        for (int k=0;k<48;k++){ //atualiza o vetor de faces com o novo indice
            if(tetfint1[k][0] == i){tetfaces2[k][0] = aux;} //indice 0 - vfaces
        }
        aux++;
}

for (int i=0; i<24; i++){// p cada vedge
        tetvertices2[aux][0] = tetev1[i][0]; //transcreve as 3 coordenadas
        tetvertices2[aux][1] = tetev1[i][1];
        tetvertices2[aux][2] = tetev1[i][2];
        
        for (int k=0;k<48;k++){ //atualiza o vetor de faces com o novo indice
            if(tetfint1[k][1] == i){tetfaces2[k][1] = aux;} //indice 1 - vedge
        }
        for (int k=0;k<48;k++){ //atualiza o vetor de faces com o novo indice
            if(tetfint1[k][3] == i){tetfaces2[k][3] = aux;} //indice 3 - vedge
        }
        aux++;
}

for (int i=0; i<14; i++){// p cada vvertex
        tetvertices2[aux][0] = tetvv1[i][0]; //transcreve as 3 coordenadas
        tetvertices2[aux][1] = tetvv1[i][1];
        tetvertices2[aux][2] = tetvv1[i][2];
        
        for (int k=0;k<48;k++){ //atualiza o vetor de faces com o novo indice
            if(tetfint1[k][2] == i){tetfaces2[k][2] = aux;} //indice 2 - vvertex
        }
        aux++;
}


//for (int i=0;i<48;i++){
//    printf("novaface%i = ( %i , %i, %i, %i )\n",i,tetfaces2[i][0],tetfaces2[i][1],tetfaces2[i][2],tetfaces2[i][3]);
//}


}





/******************************************************************************
//TERCEIRA INTERACAO
******************************************************************************/
void tetraedro_interacao3()
{
GLfloat tetfv2[48][3] = { }; //face vertex
GLfloat tetev2[96][3] = { }; //edge vertex
GLfloat tetvv2[50][3] = { }; // vertex vertex
GLint tetfint2[192][4] = { }; //faces interacao 1 com indices separados p/ fv, ev, vv
GLint tetarestas2[96][2] = { };// declaracao deve ser dentro da funcao
GLint tetarestaf2[96][2] = { };



//deriva a estrutura de arestas a partir das faces e dos vertices
int aux = 0;
for (int i=0; i<48;i++){ //p cada face
    for (int j=0; j<4;j++){ //p cada vertice de uma face (-1)
        int aux2 = 0;
        int aux1 = tetfaces2[i][j];
        if (j==3){aux2 = tetfaces2[i][0];}else{
        aux2 = tetfaces2[i][j+1];}
        
        int flag = 0; //variavel q diz se existe associacao
        for (int k=0; k<=aux;k++){ //verifica se jah existe essa associacao
            if(tetarestas2[k][0] == aux1){
                if(tetarestas2[k][1] == aux2){flag = 1;}
            }
            if(tetarestas2[k][1] == aux1){
                if(tetarestas2[k][0] == aux2){flag = 1;}
            }
        }
        if (flag == 0){ //cria associacao
           tetarestas2[aux][0] = aux1;
           tetarestas2[aux][1] = aux2;
//           printf("arestas1-%i = ( %i , %i)\n",aux,tetarestas2[aux][0],tetarestas2[aux][1]);
           aux ++;
        }
    }
}


//deriva a estrutura de arestas baseadas em faces
for (int i=0;i<96;i++){ //p cada aresta pega os 2 vertices
    int v1 = tetarestas2[i][0]; 
    int v2 = tetarestas2[i][1];

    //busca as faces vizinhas
    int k=0;
     for(int j=0;j<48;j++){ //p cada face
          if(tetfaces2[j][0] == v1 || tetfaces2[j][1] == v1 || tetfaces2[j][2] == v1 || tetfaces2[j][3] == v1){
               if(tetfaces2[j][0] == v2 || tetfaces2[j][1] == v2 || tetfaces2[j][2] == v2 || tetfaces2[j][3] == v2){
                    tetarestaf2[i][k] = j;
                    k++;
              }
          }
     }
//    printf("arestaf1-%i = ( %i , %i)\n",i,tetarestaf2[i][0],tetarestaf2[i][1]);
}



//vertices-face
for (int j = 0; j < 3; j++) {  // para cada coordenada

    for (int i = 0; i < 48; i++) { // para cada face
        
        GLfloat total = 0;
        for (int k = 0; k < 4; k++) {  // para cada vertice
            total = total + tetvertices2[tetfaces2[i][k]][j];
        }
        total = total / 4;
        tetfv2[i][j] = total;
    }
     
}

//desenha os vertices-face
for (int i = 0; i<48 ; i++){
    glPointSize(2.0);
    glBegin(GL_POINTS);
    glColor3f(1.0, 1.0, 1.0);
    glVertex3f(tetfv2[i][0],tetfv2[i][1],tetfv2[i][2]);
    glEnd();
}


//vertices-aresta
GLfloat total1, total2, total = 0; 
for (int j = 0; j < 3; j++){ //pra cada coordenada

    for (int i = 0; i < 96; i++){ // pra cada aresta
       total1 = 0; total2 = 0; total = 0;
        
        //busca nas arestas
        for (int k = 0; k < 2; k++){
            total1 = total1 + tetvertices2[tetarestas2[i][k]][j];    
        }
        total1 = total1 / 2;
        
        //busca no vface(fv)
        for (int k = 0; k < 2; k++){
            total2 = total2 + tetfv2[tetarestaf2[i][k]][j];
        }
        total2 = total2 / 2;
        total = (total1 + total2)/2;
        tetev2[i][j] = total;
    }
    
}

//desenha os vertices-aresta
for (int i = 0; i<96 ; i++){
    glPointSize(2.0);
    glBegin(GL_POINTS);
    glColor3f(0.0, 1.0, 0.0);
    glVertex3f(tetev2[i][0],tetev2[i][1],tetev2[i][2]);
    glEnd();
}


//vertices-vertice
int tetfaces_vizinhas2[50][4]; //faces vizinhas
int tetarestas_vizinhas2[50][4]; //arestas vizinhas
for (int i = 0;i<50;i++){
    for(int j=0;j<4;j++){
          tetfaces_vizinhas2[i][j] = -1;
          tetarestas_vizinhas2[i][j] = -1;          
    }
}


//busca os vertices vizinhos, pelas arestas
for (int i = 0;i<50;i++){ //p cada vertice
    int k = 0;
    for(int j=0;j<96;j++){ //p cada aresta
          if(tetarestas2[j][0] == i || tetarestas2[j][1] == i){
               if(tetarestas2[j][0] == i){tetarestas_vizinhas2[i][k] = tetarestas2[j][1];}else{
               tetarestas_vizinhas2[i][k] = tetarestas2[j][0];}
               k++;
          }
    }
//    printf("va%i = ( %i , %i , %i, %i )\n",i,tetarestas_vizinhas2[i][0],tetarestas_vizinhas2[i][1],tetarestas_vizinhas2[i][2],tetarestas_vizinhas2[i][3]); 
}

//busca as faces vizinhas
for (int i = 0;i<50;i++){ //p cada vertice
    int k = 0;
    for(int j=0;j<48;j++){ //p cada face
          if(tetfaces2[j][0] == i || tetfaces2[j][1] == i || tetfaces2[j][2] == i || tetfaces2[j][3] == i){
               tetfaces_vizinhas2[i][k] = j;
               k++;
          }
    }
 //   printf("vf%i = ( %i , %i , %i, %i )\n",i,tetfaces_vizinhas2[i][0],tetfaces_vizinhas2[i][1],tetfaces_vizinhas2[i][2],tetfaces_vizinhas2[i][3]);
}

for (int j=0;j<3;j++){ // p cada coordenada

    for (int i=0;i<50;i++){ // p cada vertice
    
        if (tetfaces_vizinhas2[i][3] == -1){
            tetvv2[i][j]=(tetvertices2[i][j]/3)*0+
                      (((tetfv2[tetfaces_vizinhas2[i][0]][j]+tetfv2[tetfaces_vizinhas2[i][1]][j]+tetfv2[tetfaces_vizinhas2[i][2]][j])/3)/3)+
                      (2*(((tetvertices2[i][j]+tetvertices2[tetarestas_vizinhas2[i][0]][j])/2+(tetvertices2[i][j]+tetvertices2[tetarestas_vizinhas2[i][1]][j])/2+(tetvertices2[i][j]+tetvertices2[tetarestas_vizinhas2[i][2]][j])/2)/3)/3);
        }else{
            tetvv2[i][j]=(tetvertices2[i][j]/4)+
                      (((tetfv2[tetfaces_vizinhas2[i][0]][j]+tetfv2[tetfaces_vizinhas2[i][1]][j]+tetfv2[tetfaces_vizinhas2[i][2]][j]+tetfv2[tetfaces_vizinhas2[i][3]][j])/4)/4)+
                      (2*(((tetvertices2[i][j]+tetvertices2[tetarestas_vizinhas2[i][0]][j])/2+(tetvertices2[i][j]+tetvertices2[tetarestas_vizinhas2[i][1]][j])/2+(tetvertices2[i][j]+tetvertices2[tetarestas_vizinhas2[i][2]][j])/2+(tetvertices2[i][j]+tetvertices2[tetarestas_vizinhas2[i][3]][j])/2)/4)/4);        
        }
    }    
}

//desenha os vertices-vertice
for (int i = 0; i<50 ; i++){
    glPointSize(2.0);
    glBegin(GL_POINTS);
    glColor3f(1.0, 1.0, 0.0);
    glVertex3f(tetvv2[i][0],tetvv2[i][1],tetvv2[i][2]);
    glEnd();
}



//monta as faces
aux = 0;
int tetarestas_validas2[2];
for (int i=0; i<48; i++){ //p cada face
    
    for (int j=0;j<4;j++){ //p cada vertice original
        
            //busca as arestas vizinhas
            int k = 0;
            for(int l=0;l<96;l++){ //p cada aresta
                  if(tetarestas2[l][0] == tetfaces2[i][j] || tetarestas2[l][1] == tetfaces2[i][j]){
                       tetarestas_vizinhas2[j][k] = l;
                       k++;
                  }
            }
//            printf("face%i = ( %i , %i , %i, %i )\n",i,tetarestas_vizinhas1[j][0],tetarestas_vizinhas1[j][1],tetarestas_vizinhas1[j][2],tetarestas_vizinhas1[j][3]);
            
            int aux2=0;
            for (int k=0;k<4;k++) { //para cada aresta encontrada (3)
                //pega apenas as 2 que fazem parte desta face
                if(tetarestaf2[tetarestas_vizinhas2[j][k]][0]==i || tetarestaf2[tetarestas_vizinhas2[j][k]][1]==i){
                     tetarestas_validas2[aux2] = tetarestas_vizinhas2[j][k];
                     aux2++;
                 }
            }
//            printf("face%i = ( %i , %i )\n",i,tetarestas_validas1[0],tetarestas_validas1[1]);
            
            tetfint2[aux][0] = i; //indice do vertice face
            tetfint2[aux][1] = tetarestas_validas2[0]; //indice do 1 vertice aresta
            tetfint2[aux][2] = tetfaces2[i][j]; //indice do vertice vertice
            tetfint2[aux][3] = tetarestas_validas2[1]; //indice do 2 vertice aresta
//            printf("novaface%i = ( %i , %i, %i, %i )\n",aux,tetfint2[aux][0],tetfint2[aux][1],tetfint2[aux][2],tetfint2[aux][3]);

/*        
        glColor3f (1.0, 1.0, 1.0);   
        glBegin(GL_LINE_STRIP);
        glVertex3f(tetfv2[tetfint2[aux][0]][0],tetfv2[tetfint2[aux][0]][1],tetfv2[tetfint2[aux][0]][2]);
        glVertex3f(tetev2[tetfint2[aux][1]][0],tetev2[tetfint2[aux][1]][1],tetev2[tetfint2[aux][1]][2]);
        glVertex3f(tetvv2[tetfint2[aux][2]][0],tetvv2[tetfint2[aux][2]][1],tetvv2[tetfint2[aux][2]][2]);
        glVertex3f(tetev2[tetfint2[aux][3]][0],tetev2[tetfint2[aux][3]][1],tetev2[tetfint2[aux][3]][2]);
        glVertex3f(tetfv2[tetfint2[aux][0]][0],tetfv2[tetfint2[aux][0]][1],tetfv2[tetfint2[aux][0]][2]);
        glEnd(); 
*/           
            
            aux ++;
    }
}




//transcreve os novos vertices para um vetor apenas
aux = 0;
for (int i=0; i<48; i++){// p cada vface
        tetvertices3[aux][0] = tetfv2[i][0]; //transcreve as 3 coordenadas
        tetvertices3[aux][1] = tetfv2[i][1];
        tetvertices3[aux][2] = tetfv2[i][2];
        
        for (int k=0;k<192;k++){ //atualiza o vetor de faces com o novo indice
            if(tetfint2[k][0] == i){tetfaces3[k][0] = aux;} //indice 0 - vfaces
        }
        aux++;
}

for (int i=0; i<96; i++){// p cada vedge
        tetvertices3[aux][0] = tetev2[i][0]; //transcreve as 3 coordenadas
        tetvertices3[aux][1] = tetev2[i][1];
        tetvertices3[aux][2] = tetev2[i][2];
        
        for (int k=0;k<192;k++){ //atualiza o vetor de faces com o novo indice
            if(tetfint2[k][1] == i){tetfaces3[k][1] = aux;} //indice 1 - vedge
        }
        for (int k=0;k<192;k++){ //atualiza o vetor de faces com o novo indice
            if(tetfint2[k][3] == i){tetfaces3[k][3] = aux;} //indice 3 - vedge
        }
        aux++;
}

for (int i=0; i<50; i++){// p cada vvertex
        tetvertices3[aux][0] = tetvv2[i][0]; //transcreve as 3 coordenadas
        tetvertices3[aux][1] = tetvv2[i][1];
        tetvertices3[aux][2] = tetvv2[i][2];
        
        for (int k=0;k<192;k++){ //atualiza o vetor de faces com o novo indice
            if(tetfint2[k][2] == i){tetfaces3[k][2] = aux;} //indice 2 - vvertex
        }
        aux++;
}


//for (int i=0;i<192;i++){
//    printf("novaface%i = ( %i , %i, %i, %i )\n",i,tetfaces3[i][0],tetfaces3[i][1],tetfaces3[i][2],tetfaces3[i][3]);
//}


}








// faz a rotacao
void Timer(int value)
{
    // Move o quadrado
    yRot += 1;

    if(xRot > 360)
         yRot = 0;
         
    // Redesenha vortex com as novas coordenadas
    glutPostRedisplay();
    glutTimerFunc(33,Timer, 1);
}



void
display(void)
{
  //salva estado original da matriz
  glPushMatrix();
  //
  glRotatef(xRot, 1.0f,0.0f,0.0f);
  glRotatef(yRot, 0.0f,1.0f,0.0f);           
             
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
if (tipo == 1){
  glColor3f(1.0, 1.0, 1.0);
  desenha_cubo();}
else if (tipo == 2){
  glColor3f(0.5, 0.5, 0.5);
  desenha_cubo();
  glColor3f(1.0, 1.0, 1.0);
  desenha_cubo1();
}
else if (tipo == 3){
  glColor3f(0.2, 0.2, 0.2);
  desenha_cubo();
  glColor3f(0.5, 0.5, 0.5);
  desenha_cubo1();
  glColor3f(1.0, 1.0, 1.0);
  desenha_cubo2();
}
else if (tipo == 4){
  glColor3f(0.2, 0.2, 0.2);
  desenha_cubo();
  glColor3f(0.2, 0.2, 0.2);
  desenha_cubo1();
  glColor3f(0.5, 0.5, 0.5);
  desenha_cubo2();
  glColor3f(1.0, 1.0, 1.0);
  desenha_cubo3();
}
if (tipo == 5){
  glColor3f(1.0, 1.0, 1.0);
  desenha_tetraedro();}
else if (tipo == 6){
  glColor3f(0.5, 0.5, 0.5);
  desenha_tetraedro();
  glColor3f(1.0, 1.0, 1.0);
  desenha_tetraedro1();
}
else if (tipo == 7){
  glColor3f(0.2, 0.2, 0.2);
  desenha_tetraedro();
  glColor3f(0.5, 0.5, 0.5);
  desenha_tetraedro1();
  glColor3f(1.0, 1.0, 1.0);
  desenha_tetraedro2();
}
else if (tipo == 8){
  glColor3f(0.2, 0.2, 0.2);
  desenha_tetraedro();
  glColor3f(0.2, 0.2, 0.2);
  desenha_tetraedro1();
  glColor3f(0.5, 0.5, 0.5);
  desenha_tetraedro2();
  glColor3f(1.0, 1.0, 1.0);
  desenha_tetraedro3();
}
  //recupera estado original da matriz
  glPopMatrix();
  glutSwapBuffers();
}



void init()
{
   glClearColor (0.0, 0.0, 0.0, 0.0);
   glPolygonMode(GL_FRONT, GL_LINE); 
   glFrontFace(GL_CCW);  
   glEnable(GL_MAP2_VERTEX_3);


// constroi os solidos
    cubo_interacao1();
    cubo_interacao2();
    cubo_interacao3();
    tetraedro_interacao1();
    tetraedro_interacao2();
    tetraedro_interacao3();

}

// funcao para alterar o tamanho do Objeto para caber na janela
void altera_tamanho(int w, int h)
{
   glViewport(0, 0, (GLsizei) w, (GLsizei) h);
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   if (w <= h)
      glOrtho(-tam, tam, -tam*(GLfloat)h/(GLfloat)w,
              tam*(GLfloat)h/(GLfloat)w, -tam, tam);
   else
      glOrtho(-tam*(GLfloat)w/(GLfloat)h,
              tam*(GLfloat)w/(GLfloat)h, -tam, tam, -tam, tam);
   

   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();
   glTranslatef(0.0,0.0,-1.0);
}

void KeyboardFunc ( unsigned char key, int x, int y )
{

     if(key == 'x') // fill
       { 
            xRot += 1;
       }
     if(key == 'X') // fill
       { 
            xRot -= 1;
       }
     if(key == 'y') // point
       { yRot += 1;
       }
     if(key == 'Y') // point
       { yRot -= 1;
       }  
     if(key == '1') // point
       { tipo = 1;
       }      
     if(key == '2') // point
       { tipo = 2;
       }      
     if(key == '3') // point
       { tipo = 3;
       }      
     if(key == '4') // point
       { tipo = 4;
       }   
     if(key == '5') // point
       { tipo = 5;
       }  
     if(key == '6') // point
       { tipo = 6;
       }  
     if(key == '7') // point
       { tipo = 7;
       }  
     if(key == '8') // point
       { tipo = 8;
       }     
       glutPostRedisplay();
     
}




int
main(int argc, char **argv)
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
  glutInitWindowSize(600,600);
  glutCreateWindow("Suavizacao de Solidos - Catmull-Clark");
  init();
  glutDisplayFunc(display);
  glutReshapeFunc(altera_tamanho);
  glutKeyboardFunc(KeyboardFunc);
//  glutTimerFunc(33, Timer, 1);
  glutMainLoop();
  return 0;             /* ANSI C requires main to return int. */
}
